kind: Deployment
apiVersion: apps/v1
metadata:
  name: qotd-rating
  namespace: {{ .Values.appNamespace }}
  labels:
    app: qotd
    tier: api
spec:
  replicas: 1
  selector:
    matchLabels:
      app: qotd-rating
  template:
    metadata:
      labels:
        app: qotd-rating
    spec:
      restartPolicy: Always
      containers:
        - name: qotd-rating
          image: registry.gitlab.com/quote-of-the-day/qotd-ratings-service:{{ .Values.imageTag }}
          imagePullPolicy: Always
          ports:
            - name: http
              containerPort: 3004
              protocol: TCP
          env:
            - name: LOG_LEVEL
              value: "info"
            - name: ENABLE_INSTANA
              value: "{{ .Values.enableInstana }}"
            - name: ANOMALY_GENERATOR_URL
{{ if eq .Values.useNodePort true }}
              value: "http://qotd-usecase.{{ .Values.loadNamespace }}.svc.cluster.local:3012/services/ratings"
{{ else }}
              value: "http://qotd-usecase-{{ .Values.loadNamespace }}.{{ required "Name of anomaly host is required" .Values.host }}/services/ratings"
{{ end }}
            - name: INSTANA_AGENT_HOST
              valueFrom:
                fieldRef:
                  fieldPath: status.hostIP
          livenessProbe:
            httpGet:
              path: /health
              port: 3004
            initialDelaySeconds: 60
            timeoutSeconds: 20
            periodSeconds: 60
            successThreshold: 1
            failureThreshold: 10
          readinessProbe:
            httpGet:
              path: /health
              port: 3004
            initialDelaySeconds: 5
            timeoutSeconds: 10
            periodSeconds: 10
            successThreshold: 1
            failureThreshold: 5
          resources:
            requests:
              cpu: "25m"
              memory: "200Mi"
            limits:
              cpu: "200m"
              memory: "800Mi"


{{ if eq .Values.useNodePort true }}

---
apiVersion: v1
kind: Service
metadata:
  name: qotd-rating
  namespace: {{ .Values.appNamespace }}
  labels:
    app: qotd
    tier: api
spec:
  type: ClusterIP
  ports:
    - port: 3004
      targetPort: 3004
      protocol: TCP
      name: http
  selector:
    app: qotd-rating

{{ else }}

---
apiVersion: v1
kind: Service
metadata:
  name: qotd-rating
  namespace: {{ .Values.appNamespace }}
  labels:
    app: qotd
    tier: api
spec:
  type: ClusterIP
  ports:
    - port: 3004
      targetPort: 3004
      protocol: TCP
      name: http
  selector:
    app: qotd-rating


{{ end }}

